      PROGRAM HWIGPR

C---COMMON BLOCKS ARE INCLUDED AS FILE HERWIG65.INC
#include "HERWIG65.INC"
      INCLUDE "pyt_strongtyp_short.inc"  ! not #include: preprocessor crashes on
      INTEGER IEV, ITIME(10)             ! long names
      REAL TOLD, TNEW
      EXTERNAL HWUDAT

      call pyckbd
      CALL COLLIDERINI
      CALL ANZJETSINI

C---MAX NUMBER OF EVENTS THIS RUN
      MAXEV=1000
C---BEAM PARTICLES
      PART1='P'
      PART2='P'
C---BEAM MOMENTA
      PBEAM1=7000.
      PBEAM2=7000.
C---PROCESS
      IPROC=2150
C---INITIALISE OTHER COMMON BLOCKS
      CALL HWIGIN

C---USER CAN RESET PARAMETERS AT
C   THIS POINT, OTHERWISE DEFAULT
C   VALUES IN HWIGIN WILL BE USED.
cc      PTMIN=20.
      MODBOS(1)=15

C---COMPUTE PARAMETER-DEPENDENT CONSTANTS
      CALL HWUINC
C---CALL HWUSTA TO MAKE ANY PARTICLE STABLE
C      CALL HWUSTA('PI0     ')
C---USER'S INITIAL CALCULATIONS
      CALL HWABEG
C---INITIALISE ELEMENTARY PROCESS
      CALL HWEINI
cc      MSTU(15)=1

C...Starting time
      CALL PYTIME(ITIME)
      TOLD=3600D0*ITIME(4)+60D0*ITIME(5)+ITIME(6)

C---LOOP OVER EVENTS -----------------------------
      DO 100 IEV=1,MAXEV
C---INITIALISE EVENT
      CALL HWUINE
C---GENERATE HARD SUBPROCESS
      CALL HWEPRO
C---GENERATE PARTON CASCADES
      CALL HWBGEN
C---DO HEAVY OBJECT DECAYS
      CALL HWDHOB
C---DO CLUSTER FORMATION
      CALL HWCFOR
C---DO CLUSTER DECAYS
      CALL HWCDEC
C---DO UNSTABLE PARTICLE DECAYS
      CALL HWDHAD
C---DO HEAVY FLAVOUR HADRON DECAYS
      CALL HWDHVY
C---ADD SOFT UNDERLYING EVENT IF NEEDED
      CALL HWMEVT
C---FINISH EVENT
      CALL HWUFNE
C---USER'S EVENT ANALYSIS
      CALL HWANAL(IEV)

      if(IEV.eq.1) write(6,661) MAXEV, 250.*float(MAXEV)/10000.

  100 CONTINUE ! -------------------------------

C---TERMINATE ELEMENTARY PROCESS
      CALL HWEFIN

C...Finishing time
      CALL PYTIME(ITIME)
      TNEW=3600D0*ITIME(4)+60D0*ITIME(5)+ITIME(6)

      write(6,666) MAXEV, TNEW-TOLD

661   format(/I6, ' Events, will take about ', f8.1,
     &       ' seconds on P4-1600'/)

666   format(/ I6, ' Events generated in ', f10.4,
     &       ' seconds ')

C---USER'S TERMINAL CALCULATIONS
      CALL HWAEND
      STOP
      END

C----------------------------------------------------------------------
      SUBROUTINE HWABEG
C     USER'S ROUTINE FOR INITIALIZATION
C----------------------------------------------------------------------
      END

C----------------------------------------------------------------------
      SUBROUTINE HWAEND
C     USER'S ROUTINE FOR TERMINAL CALCULATIONS, HISTOGRAM OUTPUT, ETC
C----------------------------------------------------------------------
      CALL ANZJETSOUT
      END
C----------------------------------------------------------------------

      SUBROUTINE HWANAL(IEV)
C     USER'S ROUTINE TO ANALYSE DATA FROM EVENT
C----------------------------------------------------------------------
      integer IEV
      INCLUDE "pyt_strongtyp_short.inc"  ! not #include: preprocessor crashes on
cc      if(IEV.le.1) call pylist(5)
      call pyhepc(2)
      if(IEV.le.1) call pylist(1)

        CALL ANZJETS

      END

* MK: this routine is modified in order to understand some additional
* HERWIG status codes when reading in HEPEVT.

      INCLUDE "../data/pyhepc_herwig.f"
