CDECK  ID>, HWD4M0.
*CMZ :-        -11/10/01  12:32:39  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWD4M0(ID,WGT)
C-----------------------------------------------------------------------
C     Subroutine to calculate the matrix element for a given four body
C     decay mode
C-----------------------------------------------------------------------
#include "HERWIG65.INC"
      INTEGER I,J,P0,P1,P2,P3,ID,O(2),IDP(4+NDIAGR),II,P4
      DOUBLE PRECISION A,B,MS,MWD,M,M2,WGT,HWRUNI,
     &     M23,PCMA,PCMB(2),HWUPCM,PHS,N(3),HWVDOT,PP,HWULDO,EPS,
     &     M232,PRE,PLAB,PRW,XMASS,PCM,P(5,5),PM(5,5),MR,PREF(5),
     &     M45,M452,MJAC(2),PTMP(5,2),CN(2),DOT
      DOUBLE COMPLEX S,D,ME(2,2,2,2),APP(2,2),AMP(2,2),APM(2,2),
     &     AMM(2,2),BPP(2,2),BPM(2,2),BMP(2,2),BMM(2,2),ZI,
     &     F45(2,2,8,8),F23(2,2,8,8),C(2,2),E(2,2)
      LOGICAL HWRLOG
      EXTERNAL HWRUNI,HWUPCM,HWVDOT,HWULDO,HWRLOG
      COMMON/HWHEWP/XMASS(10),PLAB(5,10),PRW(5,2),PCM(5,10)
      COMMON/HWD4BY/A(2),B(2),MS(2),MWD(2),MR(2),M(5),M2(5),P,IDP
      COMMON/HWHEWS/S(8,8,2),D(8,8)
      PARAMETER(EPS=1D-20,ZI=(0.0D0,1.0D0))
      SAVE O,PREF
      DATA O/2,1/
      DATA PREF/1.0D0,0.0D0,0.0D0,1.0D0,0.0D0/
C--select the masses of the gauge bosons and compute Jacobians
      IF(HWRLOG(HALF)) THEN
        CALL HWHGB1(1,2,IDP(6),MJAC(1),M232,(M(1)-M(4)-M(5))**2,
     &                                             (M(2)+M(3))**2)
        M23 = SQRT(M232)
        CALL HWHGB1(1,2,IDP(7),MJAC(2),M452,
     &       (M(1)-M23)**2,(M(4)+M(5))**2)
        M45 = SQRT(M452)
      ELSE
        CALL HWHGB1(1,2,IDP(7),MJAC(2),M452,(M(1)-M(2)-M(3))**2,
     &                                            (M(4)+M(5))**2)
        M45 = SQRT(M452)
        CALL HWHGB1(1,2,IDP(6),MJAC(1),M232,(M(1)-M45)**2,
     &       (M(2)+M(3))**2)
        M23 = SQRT(M232)
      ENDIF
      MJAC(1) = MJAC(1)/((M232-MS(1))**2+MWD(1)**2)
      MJAC(2) = MJAC(2)/((M452-MS(2))**2+MWD(2)**2)
      DO 1 I=2,5
 1    P(5,I) = M(I)
      DO 2 I=1,2
 2    CN(I) = -ONE/MS(I)
C--now perform the decay of the Higgs to the bosons
      PCMA = HWUPCM(M(1),M23,M45)
      PLAB(5,1) = M23
      PLAB(5,2) = M45
      CALL HWVEQU(5,PHEP(1,ID),P(1,1))
      CALL HWDTWO(P(1,1),PLAB(1,1),PLAB(1,2),PCMA,2.0D0,.TRUE.)
      PCMB(1) = HWUPCM(M23,M(2),M(3))
      CALL HWDTWO(PLAB(1,1),P(1,2),P(1,3),PCMB(1),2.0D0,.TRUE.)
      PCMB(2) = HWUPCM(M45,M(4),M(5))
      CALL HWDTWO(PLAB(1,2),P(1,4),P(1,5),PCMB(2),2.0D0,.TRUE.)
      DOT = HWULDO(PLAB(1,1),PLAB(1,2))
C--compute the phase sapce factors
      PHS = PCMA*PCMB(1)*PCMB(2)*MJAC(1)*MJAC(2)/512.0D0/PIFAC**5/
     &        M2(1)/M23/M45
C--compute the vectors for the helicity amplitudes
      DO 3 I=1,4
      II=I+1
C--compute the references vectors
C--not important if SM particle which can't have spin measured
C--ie anything other the top and tau
C--also not important if particle is approx massless
C--first the SM particles other than top and tau
      IF(IDP(II).LT.400.AND.(IDP(II).NE.6.AND.IDP(II).NE.12
     &                 .AND.IDP(II).NE.125.AND.IDP(II).NE.131)) THEN
        CALL HWVEQU(5,PREF,PLAB(1,I+4))
C--all other particles
      ELSE
        PP = SQRT(HWVDOT(3,P(1,II),P(1,II)))
        CALL HWVSCA(3,ONE/PP,P(1,II),N)
        PLAB(4,I+4) = HALF*(P(4,II)-PP)
        PP = HALF*(PP-M(II)-PP**2/(M(II)+P(4,II)))
        CALL HWVSCA(3,PP,N,PLAB(1,I+4))
        CALL HWUMAS(PLAB(1,I+4))
        PP = HWVDOT(3,PLAB(1,I+4),PLAB(1,I+4))
C--fix to avoid problems if approx massless due to energy
        IF(PP.LT.EPS) CALL HWVEQU(5,PREF,PLAB(1,I+4))
      ENDIF
C--now the massless vectors
      PP = HALF*M2(II)/HWULDO(PLAB(1,I+4),P(1,II))
      DO 4 J=1,4
 4    PLAB(J,I) = P(J,II)-PP*PLAB(J,I+4)
 3    CALL HWUMAS(PLAB(1,I))
C--change ordr of momenta for call to HE code
      DO 5 I=1,5
      PM(1,I) = P(3,I)
      PM(2,I) = P(1,I)
      PM(3,I) = P(2,I)
      PM(4,I) = P(4,I)
 5    PM(5,I) = P(5,I)
      DO 6 I=1,8
      PCM(1,I)=PLAB(3,I)
      PCM(2,I)=PLAB(1,I)
      PCM(3,I)=PLAB(2,I)
      PCM(4,I)=PLAB(4,I)
 6    PCM(5,I)=PLAB(5,I)
C--compute the S functions
      CALL HWHEW2(8,PCM(1,1),S(1,1,2),S(1,1,1),D)
      DO 7 I=1,8
      DO 7 J=1,8
      S(I,J,2) = -S(I,J,2)
 7    D(I,J)   = TWO*D(I,J)
      CALL HWVSUM(4,PM(1,2),PM(1,3),PTMP(1,1))
      CALL HWVSUM(4,PM(1,4),PM(1,5),PTMP(1,2))
      CALL HWUMAS(PTMP(1,1))
      CALL HWUMAS(PTMP(1,2))
C--compute the F functions
      CALL HWH2F3(8,F23,PTMP(1,1),ZERO)
      CALL HWH2F3(8,F45,PTMP(1,2),ZERO)
C--now find the prefactor for all the diagrams
      PRE = HWULDO(PCM(1,5),PM(1,2))*HWULDO(PCM(1,6),PM(1,3))*
     &      HWULDO(PCM(1,7),PM(1,4))*HWULDO(PCM(1,8),PM(1,5))
      PRE = 0.25D0/SQRT(PRE)
C--zero the matrix element
      DO 8 P0=1,2
      DO 8 P1=1,2
      DO 8 P2=1,2
      DO 8 P3=1,2
 8    ME(P0,P1,P2,P3) = (0.0D0,0.0D0)
C--compute the A, B, C and E functions
      DO 9 P1=1,2
      DO 9 P2=1,2
        IF(P1.EQ.P2) THEN
C--the A and B functions
          APP(P1,P2) =  A(  P2 )*S(5,1,O(P1))*S(2,6,  P1 )
          APM(P1,P2) = 0.0D0
          AMP(P1,P2) = 0.0D0
          AMM(P1,P2) = -A(O(P2))*M(2)*M(3)
          BPP(P1,P2) =  B(  P2 )*S(7,3,O(P1))*S(4,8,  P1 )
          BPM(P1,P2) = 0.0D0
          BMP(P1,P2) = 0.0D0
          BMM(P1,P2) = -B(O(P2))*M(4)*M(5)
C--the C and E functions
          C(P1,P2) =CN(1)*(A(  P2 )*( M2(2)*S(5,2,O(P1))*S(2,6,  P1 )
     &                               +M2(3)*S(5,1,O(P1))*S(1,6,  P1 ))
     &         -A(O(P2))*M(2)*M(3)*( S(5,1,O(P1))*S(1,6,  P1 )
     &                              +S(5,2,O(P1))*S(2,6,  P1 )))
          E(P1,P2) =CN(2)*(B(  P2 )*( M2(4)*S(7,4,O(P1))*S(4,8,  P1 )
     &                               +M2(5)*S(7,3,O(P1))*S(3,8,  P1 ))
     &         -B(O(P2))*M(4)*M(5)*( S(7,3,O(P1))*S(3,8,  P1 )
     &                              +S(7,4,O(P1))*S(4,8,  P1 )))
        ELSE
C--the A functions
          APP(P1,P2) = 0.0D0
          APM(P1,P2) = A(  P2 )*M(2)*S(2,6,O(P1))
          AMP(P1,P2) =-A(O(P2))*M(3)*S(5,1,O(P1))
          AMM(P1,P2) = 0.0D0
          BPP(P1,P2) = 0.0D0
          BPM(P1,P2) = B(  P2 )*M(4)*S(4,8,O(P1))
          BMP(P1,P2) =-B(O(P2))*M(5)*S(7,3,O(P1))
          BMM(P1,P2) = 0.0D0
C--the C and D functions
          C(P1,P2) =CN(1)*( A(  P2 )*M(2)*( M2(3)*S(5,6,O(P1))
     &                      +S(5,1,O(P1))*S(1,2,  P1 )*S(2,6,O(P1)))
     &                     -A(O(P2))*M(3)*( M2(2)*S(5,6,O(P1))
     &                      +S(5,1,O(P1))*S(1,2,  P1 )*S(2,6,O(P1))))
          E(P1,P2) =CN(2)*( B(  P2 )*M(4)*( M2(5)*S(7,8,O(P1))
     &                      +S(7,3,O(P1))*S(3,4,  P1 )*S(4,8,O(P1)))
     &                     -B(O(P2))*M(5)*( M2(4)*S(7,8,O(P1))
     &                      +S(7,3,O(P1))*S(3,4,  P1 )*S(4,8,O(P1))))
        ENDIF
 9    CONTINUE
C--now put the whole thing together to give the matrix element
      DO 10 P1=1,2
      DO 10 P2=1,2
      DO 10 P3=1,2
      DO 10 P4=1,2
        P0=O(P1)
        IF(P1.EQ.P3) THEN
          ME(P1,P2,P3,P4) =
     & APP(P1,P2)*(S(1,3,P1)*(BPP(P3,P4)*S(4,2,P0)+BMP(P3,P4)*S(8,2,P0))
     &           +S(7,2,P0)*(BPM(P3,P4)*S(1,4,P1)+BMM(P3,P4)*S(1,8,P1)))
     &+APM(P1,P2)*(S(5,7,P0)*(BPM(P3,P4)*S(4,2,P1)+BMM(P3,P4)*S(8,2,P1))
     &           +S(3,2,P1)*(BPP(P3,P4)*S(5,4,P0)+BMP(P3,P4)*S(5,8,P0)))
     &+AMP(P1,P2)*(S(1,3,P1)*(BPP(P3,P4)*S(4,6,P0)+BMP(P3,P4)*S(8,6,P0))
     &           +S(7,6,P0)*(BPM(P3,P4)*S(1,4,P1)+BMM(P3,P4)*S(1,8,P1)))
     &+AMM(P1,P2)*(S(3,6,P1)*(BPP(P3,P4)*S(5,4,P0)+BMP(P3,P4)*S(5,8,P0))
     &           +S(5,7,P0)*(BPM(P3,P4)*S(4,6,P1)+BMM(P3,P4)*S(8,6,P1)))
        ELSE
          ME(P1,P2,P3,P4) =
     & APP(P1,P2)*(S(3,2,P0)*(BPP(P3,P4)*S(1,4,P1)+BMP(P3,P4)*S(1,8,P1))
     &           +S(1,7,P1)*(BPM(P3,P4)*S(4,2,P0)+BMM(P3,P4)*S(8,2,P0)))
     &+APM(P1,P2)*(S(5,3,P0)*(BPP(P3,P4)*S(4,2,P1)+BMP(P3,P4)*S(8,2,P1))
     &           +S(7,2,P1)*(BPM(P3,P4)*S(5,4,P0)+BMM(P3,P4)*S(5,8,P0)))
     &+AMP(P1,P2)*(S(3,6,P0)*(BPP(P3,P4)*S(1,4,P1)+BMP(P3,P3)*S(1,8,P1))
     &           +S(1,7,P1)*(BPM(P3,P4)*S(4,6,P0)+BMM(P3,P4)*S(8,6,P0)))
     &+AMM(P1,P2)*(S(5,3,P0)*(BPP(P3,P4)*S(4,6,P1)+BMP(P3,P4)*S(8,6,P1))
     &           +S(7,6,P1)*(BPM(P3,P4)*S(5,4,P0)+BMM(P3,P4)*S(5,8,P0)))
        ENDIF
      ME(P1,P2,P3,P4) = TWO*ME(P1,P2,P3,P4)
     &      +C(P1,P2)*(
     &        BPP(P3,P4)*F23(P3,P3,3,4)+BPM(P3,P4)*F23(O(P3),O(P3),7,4)
     &       +BMP(P3,P4)*F23(P3,P3,3,8)+BMM(P3,P4)*F23(O(P3),O(P3),7,8))
     &      +E(P3,P4)*(
     &        APP(P1,P2)*F45(P1,P1,1,2)+APM(P1,P2)*F45(P0,P0,5,2)
     &       +AMP(P1,P2)*F45(P1,P1,1,6)+AMM(P1,P2)*F45(P0,P0,5,6))
     &       +DOT*C(P1,P2)*E(P3,P4)
 10   ME(P1,P2,P3,P4) = PRE*ME(P1,P2,P3,P4)
C--compute the weight
      WGT = ZERO
      DO 40 P1=1,2
      DO 40 P2=1,2
      DO 40 P3=1,2
      DO 40 P4=1,2
 40   WGT = WGT+DREAL(ME(P1,P2,P3,P4)*DCONJG(ME(P1,P2,P3,P4)))
C--normalise this for phase space
      WGT = WGT*PHS
C--enter the matrix element into the spin common block
      IF(GENEV.AND.SYSPIN) THEN
        NSPN = 5
        DO 11 P1=1,2
        DO 11 P2=1,2
        DO 11 P3=1,2
        DO 11 P4=1,2
 11     MESPN(P1,P2,P3,P4,1,1) = ME(P1,P2,P3,P4)
        SPNCFC(1,1,1) = ONE
        NCFL(1) = 1
      ENDIF
      END
