CDECK  ID>, HWDBOS.
*CMZ :-        -23/05/96  18.34.17  by  Mike Seymour
*-- Author :    Mike Seymour
C-----------------------------------------------------------------------
      SUBROUTINE HWDBOS(IBOSON)
C-----------------------------------------------------------------------
C     DECAY GAUGE BOSONS (ALREADY FOUND BY HWDHAD)
C     USES SPIN DENSITY MATRIX IN RHOHEP (1ST CMPT=>-VE,2=>LONG,3=>+VE)
C     IF BOSON CAME FROM HIGGS DECAY, GIVE BOTH THE SAME HELICITY (EPR)
C     IF BOSON CAME FROM W+1JET, GIVE IT THE CORRECT DECAY CORRELATIONS
C--BRW FIX 20/07/04: ADD FULL DECAY CORRELATIONS FOR W/Z+HIGGS
C--BRW FIX 18/07/07: ADD FULL DECAY CORRELATIONS IN HIGGS->VV
C-----------------------------------------------------------------------
#include "HERWIG65.INC"
      DOUBLE PRECISION HWRGEN,HWRUNI,HWUPCM,HWULDO,R(3,3),CV,CA,BR,PCM,
     & PBOS(5),PMAX,PROB,RRLL,RLLR
      INTEGER HWRINT,IBOS,IBOSON,IPAIR,ICMF,IOPT,IHEL,IMOTH,
     & I,IQRK,IANT,ID,IQ,ITRY,JBOS
      LOGICAL QUARKS,HIGV2
      EXTERNAL HWRGEN,HWRUNI,HWUPCM,HWULDO,HWRINT
      IBOS=IBOSON
      IF (IDHW(IBOS).LT.198.OR.IDHW(IBOS).GT.200) THEN
        CALL HWWARN('HWDBOS',101)
        GOTO 999
      ENDIF
      QUARKS=.FALSE.
C---SEE IF IT IS PART OF A PAIR
      IMOTH=JMOHEP(1,IBOS)
      IPAIR=JMOHEP(2,IBOS)
      ICMF=JMOHEP(1,IBOS)
C--BRW FIX 17/07/03
      IF (IPAIR.EQ.IBOS) THEN
        IOPT=0
        IF (IPRO.EQ.26.OR.IPRO.EQ.27) ICMF=JMOHEP(1,IMOTH)
      ELSE
        IF (IDHW(ICMF).EQ.IDHW(IBOS).AND.ISTHEP(ICMF)/10.EQ.12) THEN
          IPAIR=JMOHEP(2,ICMF)
          IF (IPAIR.NE.0) THEN
            IPAIR=JDAHEP(1,IPAIR)
            IF (IPAIR.NE.0) JMOHEP(2,IPAIR)=IBOS
          ENDIF
          ICMF=JMOHEP(1,ICMF)
        ENDIF
        IOPT=0
        IF (IPAIR.NE.0) THEN
          IF (JMOHEP(2,IPAIR).NE.IBOS.OR.
     &        IDHW(IPAIR).LT.198.OR.IDHW(IPAIR).GT.200) IPAIR=0
        ENDIF
        IF (IPAIR.GT.0.AND.IPAIR.NE.IBOS) IOPT=1
      ENDIF
C--END FIX
C---SELECT DECAY PRODUCTS
   10 CALL HWDBOZ(IDHW(IBOS),IDN(1),IDN(2),CV,CA,BR,IOPT)
C---V + 1JET, V+HIGGS DECAYS ARE NOW HANDLED HERE !
      IF (IPRO.EQ.21.OR.IPRO.EQ.26.OR.IPRO.EQ.27) THEN
        IQRK=IDHW(JMOHEP(1,ICMF))
        IANT=IDHW(JMOHEP(2,ICMF))
        IF (IQRK.EQ.13 .AND. IANT.LE.6) THEN
          IQRK=JMOHEP(2,ICMF)
          IANT=JDAHEP(2,ICMF)
        ELSEIF (IQRK.EQ.13) THEN
          IQRK=JDAHEP(2,ICMF)
          IANT=JMOHEP(2,ICMF)
        ELSEIF (IANT.EQ.13 .AND. IQRK.LE.6) THEN
          IQRK=JMOHEP(1,ICMF)
          IANT=JDAHEP(2,ICMF)
        ELSEIF (IANT.EQ.13) THEN
          IQRK=JDAHEP(2,ICMF)
          IANT=JMOHEP(1,ICMF)
        ELSEIF (IQRK.GT.IANT) THEN
          IQRK=JMOHEP(2,ICMF)
          IANT=JMOHEP(1,ICMF)
        ELSE
          IQRK=JMOHEP(1,ICMF)
          IANT=JMOHEP(2,ICMF)
        ENDIF
        PHEP(5,NHEP+1)=RMASS(IDN(1))
        PHEP(5,NHEP+2)=RMASS(IDN(2))
        PCM=HWUPCM(PHEP(5,IBOS),PHEP(5,NHEP+1),PHEP(5,NHEP+2))
        IF (PCM.LT.ZERO) THEN
          CALL HWWARN('HWDBOS',103)
          GOTO 999
        ENDIF
        IF (IDHW(IBOS).EQ.200) THEN
          ID=IDN(1)
          IF (ID.GT.120) ID=ID-110
          IQ=IDHW(IQRK)
          IF (IQ.GT.6) IQ=IQ-6
          RRLL=(VFCH(IQ,1)**2+AFCH(IQ,1)**2)*
     $         (VFCH(ID,1)**2+AFCH(ID,1)**2)
     $         +4*VFCH(IQ,1)*AFCH(IQ,1)*
     $         VFCH(ID,1)*AFCH(ID,1)
          RLLR=(VFCH(IQ,1)**2+AFCH(IQ,1)**2)*
     $         (VFCH(ID,1)**2+AFCH(ID,1)**2)
     $         -4*VFCH(IQ,1)*AFCH(IQ,1)*
     $         VFCH(ID,1)*AFCH(ID,1)
        ELSE
          RRLL=ONE
          RLLR=ZERO
        ENDIF
        IF (IPRO.EQ.21) THEN
           PMAX=(RRLL+RLLR)*(HWULDO(PHEP(1,IANT),PHEP(1,IBOS))**2+
     &                       HWULDO(PHEP(1,IQRK),PHEP(1,IBOS))**2)
        ELSE
           PMAX=(RRLL+RLLR)* HWULDO(PHEP(1,IANT),PHEP(1,IBOS))*
     &                       HWULDO(PHEP(1,IQRK),PHEP(1,IBOS))
        ENDIF
 1         CALL HWDTWO(PHEP(1,IBOS),PHEP(1,NHEP+1),PHEP(1,NHEP+2),
     &                 PCM,TWO,.TRUE.)
        IF (IPRO.EQ.21) THEN
           PROB=RRLL*(HWULDO(PHEP(1,IANT),PHEP(1,NHEP+1))**2+
     &                HWULDO(PHEP(1,IQRK),PHEP(1,NHEP+2))**2)+
     &          RLLR*(HWULDO(PHEP(1,IANT),PHEP(1,NHEP+2))**2+
     &                HWULDO(PHEP(1,IQRK),PHEP(1,NHEP+1))**2)
        ELSE
           PROB=RRLL* HWULDO(PHEP(1,IANT),PHEP(1,NHEP+1))*
     &                HWULDO(PHEP(1,IQRK),PHEP(1,NHEP+2))+
     &          RLLR* HWULDO(PHEP(1,IANT),PHEP(1,NHEP+2))*
     &                HWULDO(PHEP(1,IQRK),PHEP(1,NHEP+1))
        ENDIF
        IF (PROB.GT.PMAX.OR.PROB.LT.ZERO) THEN
          CALL HWWARN('HWDBOS',104)
          GOTO 999
        ENDIF
        IF (PMAX*HWRGEN(0).GT.PROB) GOTO 1
      ELSE
C---SELECT HELICITY, UNLESS IT IS THE SECOND OF A HIGGS DECAY (EPR)
      ITRY=0
      HIGV2=IPAIR.EQ.IBOS.AND.IDHW(ICMF).EQ.201
      IF (HIGV2) THEN
        IQRK=JDAHEP(1,JBOS)
        IANT=JDAHEP(2,JBOS)
        IF (IDHW(IBOS).EQ.200) THEN
          ID=IDN(1)
          IF (ID.GT.120) ID=ID-110
          IQ=IDHW(IQRK)
          IF (IQ.GT.120) IQ=IQ-110
          RRLL=(VFCH(IQ,1)**2+AFCH(IQ,1)**2)*
     $         (VFCH(ID,1)**2+AFCH(ID,1)**2)
     $         +4*VFCH(IQ,1)*AFCH(IQ,1)*
     $         VFCH(ID,1)*AFCH(ID,1)
          RLLR=(VFCH(IQ,1)**2+AFCH(IQ,1)**2)*
     $         (VFCH(ID,1)**2+AFCH(ID,1)**2)
     $         -4*VFCH(IQ,1)*AFCH(IQ,1)*
     $          VFCH(ID,1)*AFCH(ID,1)
        ELSE
          RRLL=ONE
          RLLR=ZERO
        ENDIF
        PMAX=(RRLL+RLLR)* HWULDO(PHEP(1,IANT),PHEP(1,IBOS))*
     &                    HWULDO(PHEP(1,IQRK),PHEP(1,IBOS))
      ELSE
       IF (RHOHEP(1,IBOS)+RHOHEP(2,IBOS)+RHOHEP(3,IBOS).LE.ZERO) THEN
C---COPY PARENT HELICITY IF IT WAS A GAUGE BOSON
        IF (IDHW(IMOTH).GE.198.AND.IDHW(IMOTH).LE.200) THEN
          CALL HWVEQU(3,RHOHEP(1,IMOTH),RHOHEP(1,IBOS))
          IF (RHOHEP(1,IBOS)+RHOHEP(2,IBOS)+RHOHEP(3,IBOS).GT.ZERO)
     &    GOTO 20
C---MAY BE FROM A SUSY DECAY
        ELSEIF (ABS(IDHEP(IMOTH)).LT.1000000) THEN
          CALL HWWARN('HWDBOS',1)
        ENDIF
        RHOHEP(1,IBOS)=1.
        RHOHEP(2,IBOS)=1.
        RHOHEP(3,IBOS)=1.
       ENDIF
 20    IHEL=HWRINT(1,3)
       IF (HWRGEN(0).GT.RHOHEP(IHEL,IBOS)) GOTO 20
      ENDIF
C---SELECT DIRECTION OF FERMION
 25   ITRY=ITRY+1
      IF (ITRY.GT.NDTRY) THEN
           CALL HWWARN('HWDBOS',105)
           GOTO 999
      ENDIF
 30   COSTH=HWRUNI(0,-ONE,ONE)
      IF (HIGV2) GOTO 32
      IF (IHEL.EQ.1 .AND. (ONE+COSTH)**2.LT.HWRGEN(0)*FOUR) GOTO 30
      IF (IHEL.EQ.2 .AND. (ONE-COSTH**2).LT.HWRGEN(0)     ) GOTO 30
      IF (IHEL.EQ.3 .AND. (ONE-COSTH)**2.LT.HWRGEN(0)*FOUR) GOTO 30
C---GENERATE DECAY RELATIVE TO Z-AXIS
 32   PHEP(5,NHEP+1)=RMASS(IDN(1))
      PHEP(5,NHEP+2)=RMASS(IDN(2))
      PCM=HWUPCM(PHEP(5,IBOS),PHEP(5,NHEP+1),PHEP(5,NHEP+2))
      IF (PCM.LT.ZERO) THEN
        CALL HWWARN('HWDBOS',102)
        GOTO 999
      ENDIF
      CALL HWRAZM(PCM*SQRT(1-COSTH**2),PHEP(1,NHEP+1),PHEP(2,NHEP+1))
      PHEP(3,NHEP+1)=PCM*COSTH
      PHEP(4,NHEP+1)=SQRT(PHEP(5,NHEP+1)**2+PCM**2)
C---ROTATE SO THAT Z-AXIS BECOMES BOSON'S DIRECTION IN ORIGINAL CM FRAME
      CALL HWULOF(PHEP(1,ICMF),PHEP(1,IBOS),PBOS)
      CALL HWUROT(PBOS, ONE,ZERO,R)
      CALL HWUROB(R,PHEP(1,NHEP+1),PHEP(1,NHEP+1))
C---BOOST BACK TO LAB
C--BRW FIX 30/11/08: BOOST FIRST TO HIGGS RF, THEN TO LAB
      CALL HWULOB(PBOS,PHEP(1,NHEP+1),PHEP(1,NHEP+1))
      CALL HWULOB(PHEP(1,ICMF),PHEP(1,NHEP+1),PHEP(1,NHEP+1))
C--END BRW FIX
      CALL HWVDIF(4,PHEP(1,IBOS),PHEP(1,NHEP+1),PHEP(1,NHEP+2))
      IF (HIGV2) THEN
C---HIGGS->VV DECAY CORRELATION
         PROB=RRLL* HWULDO(PHEP(1,IANT),PHEP(1,NHEP+2))*
     &              HWULDO(PHEP(1,IQRK),PHEP(1,NHEP+1))+
     &        RLLR* HWULDO(PHEP(1,IANT),PHEP(1,NHEP+1))*
     &              HWULDO(PHEP(1,IQRK),PHEP(1,NHEP+2))
         IF (PROB.GT.PMAX.OR.PROB.LT.ZERO) THEN
           CALL HWWARN('HWDBOS',106)
           GOTO 999
         ENDIF
         IF (PMAX*HWRGEN(0).GT.PROB) GOTO 25
      ENDIF
      ENDIF
C---STATUS, IDs AND POINTERS
      ISTHEP(IBOS)=195
      DO 50 I=1,2
        ISTHEP(NHEP+I)=193
        IDHW(NHEP+I)=IDN(I)
        IDHEP(NHEP+I)=IDPDG(IDN(I))
        JDAHEP(I,IBOS)=NHEP+I
        JMOHEP(1,NHEP+I)=IBOS
        JMOHEP(2,NHEP+I)=JMOHEP(1,IBOS)
 50   CONTINUE
      NHEP=NHEP+2
      IF (IDN(1).LE.12) THEN
        ISTHEP(NHEP-1)=113
        ISTHEP(NHEP)=114
        JMOHEP(2,NHEP)=NHEP-1
        JDAHEP(2,NHEP)=NHEP-1
        JMOHEP(2,NHEP-1)=NHEP
        JDAHEP(2,NHEP-1)=NHEP
        QUARKS=.TRUE.
      ELSE
C--MHS FIX 07/03/05 - VERTEX POSITION FOR DECAYS TO LEPTONS
        CALL HWVEQU(4,VTXPIP,VHEP(1,NHEP-1))
        CALL HWVEQU(4,VTXPIP,VHEP(1,NHEP))
C--END FIX
      ENDIF
C---IF FIRST OF A PAIR, DO SECOND DECAY
      IF (IPAIR.NE.0 .AND. IPAIR.NE.IBOS) THEN
        JBOS=IBOS
        IBOS=IPAIR
        GOTO 10
      ENDIF
C---IF QUARK DECAY, HADRONIZE
      IF (QUARKS) THEN
        EMSCA=PHEP(5,IBOS)
        CALL HWBGEN
        CALL HWDHOB
        CALL HWCFOR
        CALL HWCDEC
      ENDIF
 999  RETURN
      END
