CDECK  ID>, HWISP2.
*CMZ :-        -30/09/02  14:05:28  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWISP2
C-----------------------------------------------------------------------
C     Initialise the SUSY two body modes for spin correlations
C-----------------------------------------------------------------------
#include "HERWIG65.INC"
      INTEGER I,J,IL,IH,L,L1,IM,O(2),II,JJ,III,JJJ,KKK
      COMMON /HWSPNC/ SW,CW,TW,E,G,RT,ORT,MW,MZ,GS,AFN,AFG,AFC,OIJ,OIJP,
     &               OIJPP,HNN,HCC,HNC,HFF,HWW,HZZ,ZAB,HHB
      DOUBLE PRECISION SW,CW,TW,E,G,RT,ORT,MW,MZ,GS,AFN(2,12,2,4),
     &     AFG(2,6,2),AFC(2,12,2,2),OIJ(2,4,2),OIJP(2,2,2),OIJPP(2,4,4),
     &     HNN(2,3,4,4),HCC(2,3,2,2),HNC(2,4,2),HFF(2,4,12),HWW(2),
     &     HZZ(2),ZAB(12,2,2),HHB(2,3),FPI
      SAVE O,FPI
      DATA O/2,1/
      DATA FPI/0.09298D0/
      IF(IERROR.NE.0.OR..NOT.SUSYIN) RETURN
C--now the two body modes for spin corrections
      DO 1000 JJ=1,NRES
      DO 1000 II=1,NMODES(JJ)
        IF(II.EQ.1) THEN
          I = LSTRT(JJ)
        ELSE
          I = LNEXT(I)
        ENDIF
        IF(IDKPRD(2,I).EQ.0.OR.IDKPRD(3,I).NE.0.OR.
     &        (NME(I).GT.10000.AND.NME(I).LT.50000)) GOTO 1000
        L1 = IDK(I)-449
C--two body top to charged higgs decay
        IF(IDK(I).EQ.6.AND.IDKPRD(1,I).EQ.206.AND.
     &                     IDKPRD(2,I).EQ.5) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',100)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 2
            P2MODE(N2MODE) = ONE
            DO 201 J=1,2
 201        A2MODE(J,N2MODE) = HFF(O(J),4,3)
C--two body antitop to charged higgs
        ELSEIF(IDK(I).EQ.12.AND.IDKPRD(1,I).EQ.207.AND.
     &                          IDKPRD(2,I).EQ.11) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',101)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 14
            P2MODE(N2MODE) = ONE
            DO 202 J=1,2
 202        A2MODE(J,N2MODE) = HFF(  J ,4,3)
C--two body modes of the gluino
        ELSEIF(L1.EQ.0) THEN
          L = IDKPRD(1,I)-449
C--gluino to antisfermion fermion
          IF(IDPDG(IDKPRD(2,I)).GT.0.AND.L.GE.-48.AND.L.LE.-1) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',102)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 2
            P2MODE(N2MODE) = HALF
            IM = MOD(INT((IDKPRD(1,I)-389)/12)+1,2)+1
            IL = 6*INT((IDKPRD(1,I)-401)/24)+MOD(IDKPRD(1,I)-401,6)+1
            DO 1 J=1,2
 1          A2MODE(J,N2MODE) = AFG(J,IL,IM)
C--gluino to sfermion antifermion
          ELSEIF(IDPDG(IDKPRD(2,I)).LT.0.AND.L.GE.-48.AND.L.LE.-1) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',103)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 3
            P2MODE(N2MODE) = HALF
            IM = MOD(INT((IDKPRD(1,I)-389)/12)+1,2)+1
            IL = 6*INT((IDKPRD(1,I)-401)/24)+MOD(IDKPRD(1,I)-401,6)+1
            DO 2 J=1,2
 2          A2MODE(J,N2MODE) = AFG(O(J),IL,IM)
C--gluino to neutralino gluon
          ELSEIF(L.GE.1.AND.L.LE.4.AND.IDKPRD(2,I).EQ.13) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',104)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 4
            P2MODE(N2MODE) = 8.0D0*PIFAC*RMASS(IDK(I))**3/
     &           (RMASS(IDK(I))**2-RMASS(IDKPRD(1,I))**2)**3*
     &           HBAR/RLTIM(IDK(I))*BRFRAC(I)
            A2MODE(1,N2MODE) = ZSGNSS(L)
C--gluino to gravitino gluon
          ELSEIF(IDKPRD(1,I).EQ.458.AND.IDKPRD(2,I).EQ.13) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',105)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 9
            P2MODE(N2MODE) = ONE/24.0D0
          ENDIF
C--two body modes of the neutralinos
        ELSEIF(L1.GE.1.AND.L1.LE.4) THEN
          L  = IDKPRD(1,I)-449
          IH = IDKPRD(2,I)-202
C--first the neutralino modes to neutralino Higgs
          IF(L.GE.1.AND.L.LE.4.AND.IH.GE.1.AND.IH.LE.3) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GE.NMODE2) THEN
              CALL HWWARN('HWISP2',106)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 1
            P2MODE(N2MODE) = ONE
            DO 3 J=1,2
 3          A2MODE(J,N2MODE) = HNN(J,IH,L,L1)
C--neutralino to positive chargino negative Higgs
          ELSEIF((L.EQ.5.OR.L.EQ.6).AND.IH.EQ.5) THEN
            L = L-4
            N2MODE = N2MODE+1
            IF(N2MODE.GE.NMODE2) THEN
              CALL HWWARN('HWISP2',107)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 1
            P2MODE(N2MODE) = ONE
            DO 4 J=1,2
 4          A2MODE(J,N2MODE) = HNC(O(J),L1,L)
C--neutralino to negative chargino positive Higgs
          ELSEIF((L.EQ.7.OR.L.EQ.8).AND.IH.EQ.6) THEN
            L = L-6
            N2MODE = N2MODE+1
            IF(N2MODE.GE.NMODE2) THEN
              CALL HWWARN('HWISP2',108)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 1
            P2MODE(N2MODE) = ONE
            DO 5 J=1,2
 5          A2MODE(J,N2MODE) = HNC(J,L1,L)
C--neutralino to antisfermion sfermion
          ELSEIF(IDPDG(IDKPRD(2,I)).GT.0.AND.L.GE.-48.AND.L.LE.-1) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',109)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 2
            P2MODE(N2MODE) = ONE
            IM = MOD(INT((IDKPRD(1,I)-389)/12)+1,2)+1
            IL = 6*INT((IDKPRD(1,I)-401)/24)+MOD(IDKPRD(1,I)-401,6)+1
            IF(IL.LE.6) P2MODE(N2MODE) = THREE
            DO 6 J=1,2
 6          A2MODE(J,N2MODE) = AFN(J,IL,IM,L1)
C--neutralino to sfermion antifermion
          ELSEIF(IDPDG(IDKPRD(2,I)).LT.0.AND.L.GE.-48.AND.L.LE.-1) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',110)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 3
            P2MODE(N2MODE) = ONE
            IM = MOD(INT((IDKPRD(1,I)-389)/12)+1,2)+1
            IL = 6*INT((IDKPRD(1,I)-401)/24)+MOD(IDKPRD(1,I)-401,6)+1
            IF(IL.LE.6) P2MODE(N2MODE) = THREE
            DO 7 J=1,2
 7          A2MODE(J,N2MODE) = AFN(O(J),IL,IM,L1)
C--neutralino to neutralino photon
          ELSEIF(L.GE.1.AND.L.LE.4.AND.IDKPRD(2,I).EQ.59) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',111)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 4
            P2MODE(N2MODE) = 8.0D0*PIFAC*RMASS(IDK(I))**3/
     &           (RMASS(IDK(I))**2-RMASS(IDKPRD(1,I))**2)**3*
     &           HBAR/RLTIM(IDK(I))*BRFRAC(I)
            A2MODE(1,N2MODE) = ZSGNSS(L)*ZSGNSS(L1)
C--neutralino to gravitino photon for GMSB
          ELSEIF(IDKPRD(1,I).EQ.458.AND.IDKPRD(2,I).EQ.59) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',112)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 9
            P2MODE(N2MODE) = ZMIXSS(L1,1)**2/24.0D0
C--neutralino to gravitino Higgs for GMSB
          ELSEIF(IDKPRD(1,I).EQ.458.AND.IH.GE.1.AND.IH.LE.3) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',113)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 10
            IF(IH.EQ.1) THEN
              P2MODE(N2MODE) = ZMIXSS(L1,3)*SINA-ZMIXSS(L1,4)*COSA
            ELSEIF(IH.EQ.2) THEN
              P2MODE(N2MODE) = ZMIXSS(L1,3)*COSA+ZMIXSS(L1,4)*SINA
            ELSE
              P2MODE(N2MODE) = ZMIXSS(L1,3)*SINB+ZMIXSS(L1,4)*COSB
            ENDIF
            P2MODE(N2MODE) = P2MODE(N2MODE)**2/3.0D0
          ELSE
            CALL HWWARN('HWISP2',1)
          ENDIF
C--two body modes of the positive charginos
        ELSEIF(L1.EQ.5.OR.L1.EQ.6) THEN
          L1 = L1-4
          L  = IDKPRD(1,I)-449
          IH = IDKPRD(2,I)-202
C--first the chargino modes to chargino Higgs
          IF((L.EQ.5.OR.L.EQ.6).AND.IH.GE.1.AND.IH.LE.3) THEN
            L = L-4
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',114)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 1
            P2MODE(N2MODE) = ONE
            DO 8 J=1,2
 8          A2MODE(J,N2MODE) = HCC(J,IH,L,L1)
C--then the chargino modes to neutralino Higgs
          ELSEIF(L.GE.1.AND.L.LE.4.AND.IH.EQ.4) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',115)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 1
            P2MODE(N2MODE) = ONE
            DO 9 J=1,2
 9          A2MODE(J,N2MODE) = HNC(J,L,L1)
C--chargino modes to antisfermion fermion
          ELSEIF(IDPDG(IDKPRD(2,I)).GT.0.AND.L.GE.-48.AND.L.LE.-1) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',116)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 2
            P2MODE(N2MODE) = ONE
            IM = MOD(INT((IDKPRD(1,I)-389)/12)+1,2)+1
            IL = 6*INT((IDKPRD(1,I)-401)/24)+MOD(IDKPRD(1,I)-401,6)+1
            IF(IL.LE.6) P2MODE(N2MODE) = THREE
            DO 10 J=1,2
 10         A2MODE(J,N2MODE) = AFC(J,IL,IM,L1)
C--chargino modes to sfermion antifermion
          ELSEIF(IDPDG(IDKPRD(2,I)).LT.0.AND.L.GE.-48.AND.L.LE.-1) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',117)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 3
            P2MODE(N2MODE) = ONE
            IM = MOD(INT((IDKPRD(1,I)-389)/12)+1,2)+1
            IL = 6*INT((IDKPRD(1,I)-401)/24)+MOD(IDKPRD(1,I)-401,6)+1
            IF(IL.LE.6) P2MODE(N2MODE) = THREE
            DO 11 J=1,2
 11         A2MODE(J,N2MODE) = AFC(O(J),IL,IM,L1)
C--chargino --> neutralino pi+
          ELSEIF(L.GE.1.AND.L.LE.4.AND.IDKPRD(2,I).EQ.38) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',118)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 7
            P2MODE(N2MODE) = FPI**2*G**2
            DO 12 J=1,2
 12         A2MODE(J,N2MODE) = OIJ(J,L,L1)
          ENDIF
C--two body modes of the negative charginos
        ELSEIF(L1.EQ.7.OR.L1.EQ.8) THEN
          L1 = L1-6
          L  = IDKPRD(1,I)-449
          IH = IDKPRD(2,I)-202
C--first the chargino modes to chargino Higgs
          IF((L.EQ.7.OR.L.EQ.8).AND.IH.GE.1.AND.IH.LE.3) THEN
            L = L-6
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',119)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 1
            P2MODE(N2MODE) = ONE
            DO 13 J=1,2
 13         A2MODE(J,N2MODE) = HCC(O(J),IH,L,L1)
C--then the chargino modes to neutralino Higgs
          ELSEIF(L.GE.1.AND.L.LE.4.AND.IH.EQ.5) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',120)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 1
            P2MODE(N2MODE) = ONE
            DO 14 J=1,2
 14         A2MODE(J,N2MODE) = HNC(O(J),L,L1)
C--chargino to antisfermion fermion
          ELSEIF(IDPDG(IDKPRD(2,I)).GT.0.AND.L.GE.-48.AND.L.LE.-1) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',121)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 2
            P2MODE(N2MODE) = ONE
            IM = MOD(INT((IDKPRD(1,I)-389)/12)+1,2)+1
            IL = 6*INT((IDKPRD(1,I)-401)/24)+MOD(IDKPRD(1,I)-401,6)+1
            IF(IL.LE.6) P2MODE(N2MODE) = THREE
            DO 15 J=1,2
 15         A2MODE(J,N2MODE) = AFC(J,IL,IM,L1)
C--chargino to sfermion antifermion
          ELSEIF(IDPDG(IDKPRD(2,I)).LT.0.AND.L.GE.-48.AND.L.LE.-1) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',122)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 3
            P2MODE(N2MODE) = ONE
            IM = MOD(INT((IDKPRD(1,I)-389)/12)+1,2)+1
            IL = 6*INT((IDKPRD(1,I)-401)/24)+MOD(IDKPRD(1,I)-401,6)+1
            IF(IL.LE.6) P2MODE(N2MODE) = THREE
            DO 16 J=1,2
 16         A2MODE(J,N2MODE) = AFC(O(J),IL,IM,L1)
C--chargino --> neutralino pi-
          ELSEIF(L.GE.1.AND.L.LE.4.AND.IDKPRD(2,I).EQ.30) THEN
            N2MODE = N2MODE+1
            IF(N2MODE.GT.NMODE2) THEN
              CALL HWWARN('HWISP2',123)
              GOTO 999
            ENDIF
            NME(I) = 30000+N2MODE
            ID2PRT(N2MODE) = I
            I2DRTP(N2MODE) = 7
            P2MODE(N2MODE) = FPI**2*G**2
            DO 17 J=1,2
 17         A2MODE(J,N2MODE) =-OIJ(O(J),L,L1)
          ENDIF
        ELSEIF(L1.GE.-48.AND.L1.LT.0) THEN
C--sfermion decay modes
          L = IDKPRD(1,I)-449
C--first sfermion modes to gluinos
          IF(L.EQ.0) THEN
C--first sfermion --> fermion gluino
            IF(IDPDG(IDKPRD(2,I)).GT.0) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',124)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 6
              P2MODE(N2MODE) = FOUR/THREE
              IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
              IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
              DO 18 J=1,2
 18           A2MODE(J,N2MODE) = AFG(J,IL,IM)
C--then antisfermion --> antifermion gluino
            ELSE
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',125)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 5
              P2MODE(N2MODE) = FOUR/THREE
              IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
              IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
              DO 19 J=1,2
 19           A2MODE(J,N2MODE) = AFG(O(J),IL,IM)
            ENDIF
C--then sfermion modes to neutralinos
          ELSEIF(L.GE.1.AND.L.LE.4) THEN
C--first sfermion --> fermion neutralino
            IF(IDPDG(IDKPRD(2,I)).GT.0) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',126)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 6
              P2MODE(N2MODE) = ONE
              IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
              IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
              DO 20 J=1,2
 20           A2MODE(J,N2MODE) = AFN(J,IL,IM,L)
C--then antisfermion --> fermion neutralino
            ELSE
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',127)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 5
              P2MODE(N2MODE) = ONE
              IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
              IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
              DO 21 J=1,2
 21           A2MODE(J,N2MODE) = AFN(O(J),IL,IM,L)
            ENDIF
C--sfermion modes to charginos
          ELSEIF(L.GE.5.AND.L.LE.8) THEN
            L = MOD(L-5,2)+1
C--first sfermion --> fermion chargino
            IF(IDPDG(IDKPRD(2,I)).GT.0) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',128)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 6
              P2MODE(N2MODE) = ONE
              IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
              IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
              DO 22 J=1,2
 22           A2MODE(J,N2MODE) = AFC(J,IL,IM,L)
C--then antisfermion --> fermion chargino
            ELSE
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',129)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 5
              P2MODE(N2MODE) = ONE
              IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
              IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
              DO 23 J=1,2
 23           A2MODE(J,N2MODE) = AFC(O(J),IL,IM,L)
            ENDIF
C--sfermion modes to  fermion gravitino
          ELSEIF(IDKPRD(2,I).EQ.458) THEN
            IF(IDPDG(IDKPRD(1,I)).GT.0) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',130)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 11
              P2MODE(N2MODE) = ONE/THREE
              IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
              IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
              IF(IL.LE.6) THEN
                DO 40 J=1,2
 40             A2MODE(J,N2MODE) = QMIXSS(IL,O(J),IM)
              ELSE
                DO 41 J=1,2
 41             A2MODE(J,N2MODE) = LMIXSS(IL-6,O(J),IM)
              ENDIF
            ELSE
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',131)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 12
              P2MODE(N2MODE) = ONE/THREE
              IM = MOD(INT((IDK(I)-389)/12)+1,2)+1
              IL = 6*INT((IDK(I)-401)/24)+MOD(IDK(I)-401,6)+1
              IF(IL.LE.6) THEN
                DO 42 J=1,2
 42             A2MODE(J,N2MODE) = QMIXSS(IL,O(J),IM)
              ELSE
                DO 43 J=1,2
 43             A2MODE(J,N2MODE) = LMIXSS(IL-6,O(J),IM)
              ENDIF
            ENDIF
C--R-parity violating decay modes
C--LLE modes
          ELSEIF(IDK(I).GE.425.AND.IDK(I).LE.448.AND.
     &           IDKPRD(1,I).GE.121.AND.IDKPRD(1,I).LE.132.AND.
     &           IDKPRD(2,I).GE.121.AND.IDKPRD(2,I).LE.132) THEN
C--charged slepton decays
            IF(MOD(IDK(I),2).EQ.1) THEN
C--right slepton decay
              IF(IDPDG(IDKPRD(1,I))/ABS(IDPDG(IDKPRD(1,I))).EQ.
     &           IDPDG(IDKPRD(2,I))/ABS(IDPDG(IDKPRD(2,I)))) THEN
C--particle decay
                N2MODE = N2MODE+1
                IF(N2MODE.GT.NMODE2) THEN
                  CALL HWWARN('HWISP2',132)
                  GOTO 999
                ENDIF
                NME(I) = 30000+N2MODE
                ID2PRT(N2MODE) = I
                P2MODE(N2MODE) = ONE
                IF(IDPDG(IDK(I)).GT.0) THEN
                  KKK = (IDK(I)-423)/2
                  IF(KKK.GT.3) THEN
                     KKK = KKK-6
                     IM = 2
                  ELSE
                     IM = 1
                  ENDIF
                  IF(MOD(IDKPRD(1,I),2).EQ.0) THEN
                    III = (IDKPRD(1,I)-120)/2
                    JJJ = (IDKPRD(2,I)-119)/2
                  ELSE
                    III = (IDKPRD(2,I)-120)/2
                    JJJ = (IDKPRD(1,I)-119)/2
                  ENDIF
                  I2DRTP(N2MODE) = 6
                  A2MODE(1,N2MODE) = LMIXSS(2*KKK-1,2,IM)*
     &                 LAMDA1(III,JJJ,KKK)
                  A2MODE(2,N2MODE) = 0.0D0
                ELSE
C--antiparticle decay
                  KKK = (IDK(I)-429)/2
                  IF(KKK.GT.3) THEN
                     KKK = KKK-6
                     IM = 2
                  ELSE
                     IM = 1
                  ENDIF
                  IF(MOD(IDKPRD(1,I),2).EQ.0) THEN
                    III = (IDKPRD(1,I)-126)/2
                    JJJ = (IDKPRD(2,I)-125)/2
                  ELSE
                    III = (IDKPRD(2,I)-126)/2
                    JJJ = (IDKPRD(1,I)-125)/2
                  ENDIF
                  I2DRTP(N2MODE) = 13
                  A2MODE(1,N2MODE) = 0.0D0
                  A2MODE(2,N2MODE) = LMIXSS(2*KKK-1,2,IM)*
     &                 LAMDA1(III,JJJ,KKK)
                ENDIF
C--left slepton decay
              ELSE
                N2MODE = N2MODE+1
                IF(N2MODE.GT.NMODE2) THEN
                  CALL HWWARN('HWISP2',133)
                  GOTO 999
                ENDIF
                NME(I) = 30000+N2MODE
                ID2PRT(N2MODE) = I
                P2MODE(N2MODE) = ONE
                IF(IDPDG(IDK(I)).GT.0) THEN
                  JJJ = (IDK(I)-423)/2
                  IF(JJJ.GT.3) THEN
                    JJJ = JJJ-6
                    IM = 2
                  ELSE
                    IM = 1
                  ENDIF
                  IF(MOD(IDKPRD(1,I),2).EQ.0) THEN
                    III = (IDKPRD(1,I)-126)/2
                    KKK = (IDKPRD(2,I)-119)/2
                    I2DRTP(N2MODE) = 8
                  ELSE
                    III = (IDKPRD(2,I)-126)/2
                    KKK = (IDKPRD(1,I)-119)/2
                    I2DRTP(N2MODE) = 5
                  ENDIF
                  A2MODE(1,N2MODE) = 0.0D0
                  A2MODE(2,N2MODE) = LMIXSS(2*JJJ-1,1,IM)*
     &                 LAMDA1(III,JJJ,KKK)
                ELSE
                  JJJ = (IDK(I)-429)/2
                  IF(JJJ.GT.3) THEN
                    JJJ = JJJ-6
                    IM = 2
                  ELSE
                    IM = 1
                  ENDIF
                  IF(MOD(IDKPRD(1,I),2).EQ.0) THEN
                    III = (IDKPRD(1,I)-120)/2
                    KKK = (IDKPRD(2,I)-125)/2
                    I2DRTP(N2MODE) = 5
                  ELSE
                    III = (IDKPRD(2,I)-120)/2
                    KKK = (IDKPRD(1,I)-125)/2
                    I2DRTP(N2MODE) = 8
                  ENDIF
                  A2MODE(1,N2MODE) = LMIXSS(2*JJJ-1,1,IM)*
     &                 LAMDA1(III,JJJ,KKK)
                  A2MODE(2,N2MODE) = 0.0D0
                ENDIF
              ENDIF
C--sneutrino decays
            ELSEIF(MOD(IDK(I),2).EQ.0.AND.IDK(I).LE.436) THEN
C--sneutrino decay
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',134)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = ONE
              IF(IDPDG(IDK(I)).GT.0) THEN
                III = (IDK(I)-424)/2
                IF(IDPDG(IDKPRD(1,I)).GT.0) THEN
                  KKK = (IDKPRD(1,I)-119)/2
                  JJJ = (IDKPRD(2,I)-125)/2
                  I2DRTP(N2MODE) = 5
                ELSE
                  JJJ = (IDKPRD(1,I)-125)/2
                  KKK = (IDKPRD(2,I)-119)/2
                  I2DRTP(N2MODE) = 8
                ENDIF
                A2MODE(1,N2MODE) = 0.0D0
                A2MODE(2,N2MODE) = LAMDA1(III,JJJ,KKK)
C--antisneutrino decay
              ELSE
                III = (IDK(I)-430)/2
                IF(IDPDG(IDKPRD(1,I)).LT.0) THEN
                  KKK = (IDKPRD(1,I)-125)/2
                  JJJ = (IDKPRD(2,I)-119)/2
                  I2DRTP(N2MODE) = 8
                ELSE
                  JJJ = (IDKPRD(1,I)-119)/2
                  KKK = (IDKPRD(2,I)-125)/2
                  I2DRTP(N2MODE) = 5
                ENDIF
                A2MODE(1,N2MODE) = LAMDA1(III,JJJ,KKK)
                A2MODE(2,N2MODE) = 0.0D0
              ENDIF
            ENDIF
C--LQD modes
C--squark decays
          ELSEIF(IDK(I).GE.401.AND.IDK(I).LE.424.AND.
     &           IDKPRD(1,I).GE.121.AND.IDKPRD(2,I).LE.132.AND.
     &           IDKPRD(2,I).LE.12) THEN
C--up type squark decay
            IF(MOD(IDK(I),2).EQ.0) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',135)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = ONE
              IF(IDPDG(IDK(I)).GT.0) THEN
                JJJ = (IDK(I)-400)/2
                IF(JJJ.GT.3) THEN
                  JJJ = JJJ-6
                  IM  = 2
                ELSE
                  IM = 1
                ENDIF
                III = (IDKPRD(1,I)-125)/2
                KKK = (IDKPRD(2,I)+1)/2
                I2DRTP(N2MODE) = 8
                A2MODE(1,N2MODE) = ZERO
                A2MODE(2,N2MODE) = QMIXSS(2*JJJ,1,IM)*
     &                             LAMDA2(III,JJJ,KKK)
              ELSE
                JJJ = (IDK(I)-406)/2
                IF(JJJ.GT.3) THEN
                  JJJ = JJJ-6
                  IM  = 2
                ELSE
                  IM = 1
                ENDIF
                III = (IDKPRD(1,I)-119)/2
                KKK = (IDKPRD(2,I)-5)/2
                I2DRTP(N2MODE) = 5
                A2MODE(1,N2MODE) = QMIXSS(2*JJJ,1,IM)*
     &                             LAMDA2(III,JJJ,KKK)
                A2MODE(2,N2MODE) = ZERO
              ENDIF
C--down type squark to lepton up
            ELSEIF(MOD(IDK(I),2).EQ.1.AND.MOD(IDKPRD(1,I),2).EQ.1) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',136)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = ONE
C--particle
              IF(IDPDG(IDK(I)).GT.0) THEN
                KKK = (IDK(I)-399)/2
                IF(KKK.GT.3) THEN
                  KKK = KKK-6
                  IM  = 2
                ELSE
                  IM  = 1
                ENDIF
                III = (IDKPRD(1,I)-119)/2
                JJJ = IDKPRD(2,I)/2
                I2DRTP(N2MODE) = 6
                A2MODE(1,N2MODE) = QMIXSS(2*KKK-1,2,IM)*
     &                             LAMDA2(III,JJJ,KKK)
                A2MODE(2,N2MODE) = ZERO
C--antiparticle
              ELSE
                KKK = (IDK(I)-405)/2
                IF(KKK.GT.3) THEN
                  KKK = KKK-6
                  IM  = 2
                ELSE
                  IM  = 1
                ENDIF
                III = (IDKPRD(1,I)-125)/2
                JJJ = (IDKPRD(2,I)-6)/2
                I2DRTP(N2MODE) = 13
                A2MODE(1,N2MODE) = ZERO
                A2MODE(2,N2MODE) = QMIXSS(2*KKK-1,2,IM)*
     &                             LAMDA2(III,JJJ,KKK)
              ENDIF
C--down (left) squark --> nu d
            ELSEIF(MOD(IDK(I),2).EQ.1.AND.
     &           IDPDG(IDK(I))/ABS(IDPDG(IDK(I))).EQ.
     &          -IDPDG(IDKPRD(1,I))/ABS(IDPDG(IDKPRD(1,I)))) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',137)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = ONE
              IF(IDPDG(IDK(I)).GT.0) THEN
                JJJ = (IDK(I)-399)/2
                IF(JJJ.GT.3) THEN
                  JJJ = JJJ-6
                  IM  = 2
                ELSE
                  IM  = 1
                ENDIF
                III = (IDKPRD(1,I)-126)/2
                KKK = (IDKPRD(2,I)+1)/2
                I2DRTP(N2MODE) = 8
                A2MODE(1,N2MODE) = ZERO
                A2MODE(2,N2MODE) = QMIXSS(2*JJJ-1,1,IM)*
     &                             LAMDA2(III,JJJ,KKK)
              ELSE
                JJJ = (IDK(I)-405)/2
                IF(JJJ.GT.3) THEN
                  JJJ = JJJ-6
                  IM = 2
                ELSE
                  IM = 1
                ENDIF
                III = (IDKPRD(1,I)-120)/2
                KKK = (IDKPRD(2,I)-5)/2
                I2DRTP(N2MODE) = 5
                A2MODE(1,N2MODE) = QMIXSS(2*JJJ-1,1,IM)*
     &                             LAMDA2(III,JJJ,KKK)
                A2MODE(2,N2MODE) = ZERO
              ENDIF
C--down (right) squark --> nu d
            ELSEIF(MOD(IDK(I),2).EQ.1.AND.
     &           IDPDG(IDK(I))/ABS(IDPDG(IDK(I))).EQ.
     &           IDPDG(IDKPRD(1,I))/ABS(IDPDG(IDKPRD(1,I)))) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',138)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = ONE
              IF(IDPDG(IDK(I)).GT.0) THEN
                KKK = (IDK(I)-399)/2
                IF(KKK.GT.3) THEN
                  KKK = KKK-6
                  IM  = 2
                ELSE
                  IM  = 1
                ENDIF
                III = (IDKPRD(1,I)-120)/2
                JJJ = (IDKPRD(2,I)+1)/2
                I2DRTP(N2MODE) = 6
                A2MODE(1,N2MODE) = QMIXSS(2*KKK-1,2,IM)*
     &                             LAMDA2(III,JJJ,KKK)
                A2MODE(2,N2MODE) = ZERO
              ELSE
                KKK = (IDK(I)-405)/2
                IF(KKK.GT.3) THEN
                  KKK = KKK-6
                  IM  = 2
                ELSE
                  IM  = 1
                ENDIF
                III = (IDKPRD(1,I)-126)/2
                JJJ = (IDKPRD(2,I)-5)/2
                I2DRTP(N2MODE) = 13
                A2MODE(1,N2MODE) = ZERO
                A2MODE(2,N2MODE) = QMIXSS(2*KKK-1,2,IM)*
     &                             LAMDA2(III,JJJ,KKK)
              ENDIF
            ELSE
              CALL HWWARN('HWISP2',2)
            ENDIF
C--slepton decays
          ELSEIF(IDK(I).GE.425.AND.IDK(I).LE.448.AND.
     &           IDKPRD(1,I).LE.12.AND.IDKPRD(2,I).LE.12) THEN
C--sneutrino decay
            IF(MOD(IDK(I),2).EQ.0) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',140)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = THREE
C--particle
              IF(IDPDG(IDK(I)).GT.0) THEN
                III = (IDK(I)-424)/2
                JJJ = (IDKPRD(1,I)-5)/2
                KKK = (IDKPRD(2,I)+1)/2
                I2DRTP(N2MODE) = 8
                A2MODE(1,N2MODE) = 0.0D0
                A2MODE(2,N2MODE) = LAMDA2(III,JJJ,KKK)
C--antiparticle
              ELSE
                III = (IDK(I)-430)/2
                JJJ = (IDKPRD(1,I)+1)/2
                KKK = (IDKPRD(2,I)-5)/2
                I2DRTP(N2MODE) = 5
                A2MODE(1,N2MODE) = LAMDA2(III,JJJ,KKK)
                A2MODE(2,N2MODE) = 0.0D0
              ENDIF
C--slepton decay
            ELSEIF(MOD(IDK(I),2).EQ.1) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',141)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = THREE
C--particle
              IF(IDPDG(IDK(I)).GT.0) THEN
                III = (IDK(I)-423)/2
                IF(III.GT.3) THEN
                   III = III -6
                   IM = 2
                ELSE
                   IM = 1
                ENDIF
                JJJ = (IDKPRD(1,I)-6)/2
                KKK = (IDKPRD(2,I)+1)/2
                I2DRTP(N2MODE) = 8
                A2MODE(1,N2MODE) = 0.0D0
                A2MODE(2,N2MODE) = LMIXSS(2*III-1,1,IM)*
     &                             LAMDA2(III,JJJ,KKK)
C--antiparticle
              ELSE
                III = (IDK(I)-429)/2
                IF(III.GT.3) THEN
                   III = III -6
                   IM = 2
                ELSE
                   IM = 1
                ENDIF
                JJJ = IDKPRD(1,I)/2
                KKK = (IDKPRD(2,I)-5)/2
                I2DRTP(N2MODE) = 5
                A2MODE(1,N2MODE) = LMIXSS(2*III-1,1,IM)*
     &                             LAMDA2(III,JJJ,KKK)
                A2MODE(2,N2MODE) = 0.0D0
              ENDIF
            ELSE
              CALL HWWARN('HWISP2',3)
            ENDIF
C--UDD modes
          ELSEIF(IDK(I).GE.401.AND.IDK(I).LE.424.AND.
     &           IDKPRD(1,I).LE.12.AND.IDKPRD(2,I).LE.12) THEN
C--up type squark decay
            IF(MOD(IDK(I),2).EQ.0) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',143)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = 2.0D0
C--squark decay
              IF(IDPDG(IDK(I)).GT.0) THEN
                III = (IDK(I)-400)/2
                IF(III.GT.3) THEN
                  III = III-6
                  IM = 2
                ELSE
                  IM = 1
                ENDIF
                JJJ = (IDKPRD(1,I)-5)/2
                KKK = (IDKPRD(2,I)-5)/2
                I2DRTP(N2MODE) = 13
                A2MODE(1,N2MODE)=QMIXSS(2*III,2,IM)*LAMDA3(III,JJJ,KKK)
                A2MODE(2,N2MODE)=0.0D0
C--antisquark decay
              ELSE
                III = (IDK(I)-406)/2
                IF(III.GT.3) THEN
                  III = III-6
                  IM = 2
                ELSE
                  IM = 1
                ENDIF
                JJJ = (IDKPRD(1,I)+1)/2
                KKK = (IDKPRD(2,I)+1)/2
                I2DRTP(N2MODE) = 6
                A2MODE(1,N2MODE) =0.0D0
                A2MODE(2,N2MODE) =QMIXSS(2*III,2,IM)*LAMDA3(III,JJJ,KKK)
              ENDIF
            ELSE
C--down type squark decay
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',144)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              P2MODE(N2MODE) = 2.0D0
C--squark decay
              IF(IDPDG(IDK(I)).GT.0) THEN
                JJJ = (IDK(I)-399)/2
                IF(JJJ.GT.3) THEN
                  JJJ = JJJ-6
                  IM = 2
                ELSE
                  IM = 1
                ENDIF
                III = (IDKPRD(1,I)-6)/2
                KKK = (IDKPRD(2,I)-5)/2
                I2DRTP(N2MODE) = 13
                A2MODE(1,N2MODE)= QMIXSS(2*JJJ-1,2,IM)*
     &                            LAMDA3(III,JJJ,KKK)
                A2MODE(2,N2MODE)= 0.0D0
C--antisquark decay
              ELSE
                JJJ = (IDK(I)-405)/2
                IF(JJJ.GT.3) THEN
                  JJJ = JJJ-6
                  IM = 2
                ELSE
                  IM = 1
                ENDIF
                III = IDKPRD(1,I)/2
                KKK = (IDKPRD(2,I)+1)/2
                I2DRTP(N2MODE) = 6
                A2MODE(1,N2MODE) = 0.0D0
                A2MODE(2,N2MODE) = QMIXSS(2*JJJ-1,2,IM)*
     &                             LAMDA3(III,JJJ,KKK)
              ENDIF
            ENDIF
          ELSE
            IF(.NOT.(RSPIN(IDKPRD(1,I)).EQ.ZERO.AND.
     &         RSPIN(IDKPRD(2,I)).EQ.ZERO)) CALL HWWARN('HWISP2',4)
          ENDIF
        ELSEIF(IDK(I).GE.203.AND.IDK(I).LE.207) THEN
          IH = IDK(I)-202
          L  = IDKPRD(1,I)-449
          L1 = IDKPRD(2,I)-449
C--Neutral Higgs decays
          IF(IH.GE.1.AND.IH.LE.3) THEN
C--Higgs to neutralino neutralino
            IF(L.GE.1.AND.L.LE.4) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',146)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 6
              P2MODE(N2MODE) = ONE
              IF(L.EQ.L1) P2MODE(N2MODE) = HALF
              DO 24 J=1,2
 24           A2MODE(J,N2MODE) = HNN(J,IH,L,L1)
C--Higgs to chargino chargino
            ELSEIF(L.GE.5.AND.L.LE.8) THEN
              L  = MOD(L -5,2)+1
              L1 = MOD(L1-5,2)+1
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',147)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 6
              P2MODE(N2MODE) = ONE
              DO 25 J=1,2
              IF(IDPDG(IDKPRD(1,I)).GT.0) THEN
                A2MODE(J,N2MODE) = HCC(  J ,IH,L,L1)
              ELSE
                A2MODE(J,N2MODE) = HCC(O(J),IH,L,L1)
              ENDIF
 25           CONTINUE
C--Higgs to fermion antifermion
            ELSEIF((L.GE.-448.AND.L.LE.-437)
     &         .OR.(L.GE.-328.AND.L.LE.-317)) THEN
              N2MODE = N2MODE+1
              IF(N2MODE.GT.NMODE2) THEN
                CALL HWWARN('HWISP2',148)
                GOTO 999
              ENDIF
              NME(I) = 30000+N2MODE
              ID2PRT(N2MODE) = I
              I2DRTP(N2MODE) = 5
              P2MODE(N2MODE) = ONE
              IL = IDKPRD(1,I)
              IL = IL-6*INT((IL-1)/6)+6*INT((IL-1)/120)
              IF(IL.LE.6) P2MODE(N2MODE) = THREE
              DO 26 J=1,2
 26           A2MODE(J,N2MODE) = HFF(J,IH,IL)
            ELSE
              IF(.NOT.
     &       (RSPIN(IDKPRD(1,I)).EQ.ZERO.AND.RSPIN(IDKPRD(2,I)).EQ.ZERO)
     &        .AND..NOT.(IDKPRD(1,I).EQ.13.AND.IDKPRD(2,I).EQ.13)
     &        .AND..NOT.(IDKPRD(1,I).EQ.59.AND.IDKPRD(2,I).EQ.59)
     &        .AND..NOT.(IDKPRD(1,I).GE.198.AND.IDKPRD(1,I).LE.200.AND.
     &                   IDKPRD(2,I).GE.198.AND.IDKPRD(2,I).LE.200))
     &        CALL HWWARN('HWISP2',5)
            ENDIF
C--charged Higgs decays
          ELSE
            IH = IDK(I)-205
            L  = IDKPRD(1,I)-449
            L1 = IDKPRD(2,I)-449
C--positive Higgs decays
            IF(IH.EQ.1) THEN
C--decay to chargino neutralino
              IF(L.EQ.5.OR.L.EQ.6) THEN
                L = L-4
                N2MODE = N2MODE+1
                IF(N2MODE.GT.NMODE2) THEN
                  CALL HWWARN('HWISP2',149)
                  GOTO 999
                ENDIF
                NME(I) = 30000+N2MODE
                ID2PRT(N2MODE) = I
                I2DRTP(N2MODE) = 6
                P2MODE(N2MODE) = ONE
                DO 27 J=1,2
 27             A2MODE(J,N2MODE) = HNC(O(J),L1,L)
C--decay to neutralino chargino
              ELSEIF(L.GE.1.AND.L.LE.4) THEN
                L1 = L1-4
                N2MODE = N2MODE+1
                IF(N2MODE.GT.NMODE2) THEN
                  CALL HWWARN('HWISP2',150)
                  GOTO 999
                ENDIF
                NME(I) = 30000+N2MODE
                ID2PRT(N2MODE) = I
                I2DRTP(N2MODE) = 6
                P2MODE(N2MODE) = ONE
                DO 28 J=1,2
 28             A2MODE(J,N2MODE) = HNC(O(J),L1,L)
C--fermion antifermion decay modes
              ELSEIF((L.GE.-448.AND.L.LE.-437)
     &               .OR.(L.GE.-328.AND.L.LE.-317)) THEN
                N2MODE = N2MODE+1
                IF(N2MODE.GT.NMODE2) THEN
                  CALL HWWARN('HWISP2',151)
                  GOTO 999
                ENDIF
                NME(I) = 30000+N2MODE
                ID2PRT(N2MODE) = I
                I2DRTP(N2MODE) = 5
                P2MODE(N2MODE) = ONE
                IL = IDKPRD(1,I)
                IL = IL-6*INT((IL-1)/6)+6*INT((IL-1)/120)
                IL = INT((IL+1)/2)
                IF(IL.LE.3) P2MODE(N2MODE) = THREE
                DO 29 J=1,2
 29             A2MODE(J,N2MODE) = HFF(J,4,IL)
              ELSE
                IF(RSPIN(IDKPRD(1,I)).NE.ZERO.OR.RSPIN(IDKPRD(2,I)).NE.
     &           ZERO) CALL HWWARN('HWISP2',6)
              ENDIF
C--negative Higgs decays
            ELSE
C--Higgs to chargino neutralino
              IF(L.EQ.7.OR.L.EQ.8) THEN
                L = L-6
                N2MODE = N2MODE+1
                IF(N2MODE.GT.NMODE2) THEN
                  CALL HWWARN('HWISP2',152)
                  GOTO 999
                ENDIF
                NME(I) = 30000+N2MODE
                ID2PRT(N2MODE) = I
                I2DRTP(N2MODE) = 6
                P2MODE(N2MODE) = ONE
                DO 30 J=1,2
 30             A2MODE(J,N2MODE) = HNC(J,L1,L)
C--Higgs to neutralino chargino
              ELSEIF(L.GE.1.AND.L.LE.4) THEN
                L1 = L1-6
                N2MODE = N2MODE+1
                IF(N2MODE.GT.NMODE2) THEN
                  CALL HWWARN('HWISP2',153)
                  GOTO 999
                ENDIF
                NME(I) = 30000+N2MODE
                ID2PRT(N2MODE) = I
                I2DRTP(N2MODE) = 6
                P2MODE(N2MODE) = ONE
                DO 31 J=1,2
 31             A2MODE(J,N2MODE) = HNC(J,L1,L)
C--fermion antifermion decay modes
              ELSEIF((L.GE.-448.AND.L.LE.-437)
     &               .OR.(L.GE.-328.AND.L.LE.-317)) THEN
                N2MODE = N2MODE+1
                IF(N2MODE.GT.NMODE2) THEN
                  CALL HWWARN('HWISP2',154)
                  GOTO 999
                ENDIF
                NME(I) = 30000+N2MODE
                ID2PRT(N2MODE) = I
                I2DRTP(N2MODE) = 8
                P2MODE(N2MODE) = ONE
                IL = IDKPRD(1,I)
                IL = IL-6*INT((IL-1)/6)+6*INT((IL-1)/120)
                IL = INT((IL+1)/2)
                IF(IL.LE.3) P2MODE(N2MODE) = THREE
                DO 32 J=1,2
 32             A2MODE(J,N2MODE) = HFF(O(J),4,IL)
              ELSE
                IF(RSPIN(IDKPRD(1,I)).NE.ZERO.OR.RSPIN(IDKPRD(1,I)).NE.
     &           ZERO) CALL HWWARN('HWISP2',7)
              ENDIF
            ENDIF
          ENDIF
        ENDIF
 1000 CONTINUE
C--now find the maximum weights and compute the decay rates
      DO 2000 I=1,N2MODE
      IF(IPRINT.GE.2) WRITE(6,5010) RNAME(IDK(ID2PRT(I))),
     &   RNAME(IDKPRD(1,ID2PRT(I))),RNAME(IDKPRD(2,ID2PRT(I)))
 2000 CALL HWD2ME(I)
      RETURN
 5010 FORMAT(/'CALCULATING TWO BODY DECAY ',
     &     A8,' --> ',A8,' ',A8/)
 999  RETURN
      END
